#/usr/bin/perl -w

if($#ARGV < 1)
{
	die "usage: generate-version <version> <target_dir> <source files>\n";
}

$version = shift(@ARGV);
$target_dir = shift(@ARGV);
print "version: $version\n";
print "target_dir: $target_dir\n";

foreach $file (@ARGV) {
	open(READFILE,$file);
	$file =~/.*\/(.+)$/iog;
	if($1 eq "") {
		$target_file = $file;
	} else {
		$target_file = $1;
	}

	open(WRITEFILE,">$target_dir/$target_file");
	print "$file => $target_dir/$target_file\n";
	$proper_version = 1;
	print WRITEFILE "/* This is code for version $version\n";
	print WRITEFILE "   It's generated, so don't bother editing it */\n";
	while(<READFILE>) {
		if(/^\s*#ifdef\s+/iog) {
			if(! /$version\s*$/iog) {
				$proper_version = 0;
			}
			next;
		}
		if(/^\s*#endif\s*$/iog) {
			$proper_version = 1;
			next;
		}
		if($proper_version) {
			print WRITEFILE;
		}
	}
	close(WRITEFILE);
	close(READFILE);
}
